## tig 2.0.2

=== Makefile ===
## Makefile for tig

# The last tagged version. Can be overridden either by the version from
# git or from the value of the DIST_VERSION environment variable.
VERSION	= 2.0.2

all:

# Include kernel specific configuration
kernel_name := $(shell sh -c 'uname -s 2>/dev/null || echo unknown')
-include contrib/config.make-$(kernel_name)

# Include setting from the configure script
-include config.make

prefix ?= $(HOME)
bindir ?= $(prefix)/bin
datarootdir ?= $(prefix)/share
sysconfdir ?= $(prefix)/etc
docdir ?= $(datarootdir)/doc
mandir ?= $(datarootdir)/man
# DESTDIR=

ifneq (,$(wildcard .git))
GITDESC	= $(subst tig-,,$(shell git describe 2>/dev/null))
COMMIT := $(if $(GITDESC),$(GITDESC),$(VERSION)-g$(shell git describe --always))
WTDIRTY	= $(if $(shell git diff-index HEAD 2>/dev/null),-dirty)
VERSION	= $(COMMIT)$(WTDIRTY)
endif
ifdef DIST_VERSION
VERSION = $(DIST_VERSION)
endif

# Split the version "TAG-OFFSET-gSHA1-DIRTY" into "TAG OFFSET"
# and append 0 as a fallback offset for "exact" tagged versions.
RPM_VERLIST = $(filter-out g% dirty,$(subst -, ,$(VERSION))) 0
RPM_VERSION = $(word 1,$(RPM_VERLIST))
RPM_RELEASE = $(word 2,$(RPM_VERLIST))$(if $(WTDIRTY),.dirty)

LDLIBS ?= -lcurses
CFLAGS ?= -Wall -O2
DFLAGS	= -g -DDEBUG -Werror -O0
EXE	= src/tig
TOOLS	= test/test-graph tools/doc-gen
TXTDOC	= doc/tig.1.adoc doc/tigrc.5.adoc doc/manual.adoc NEWS.adoc README.adoc INSTALL.adoc
MANDOC	= doc/tig.1 doc/tigrc.5 doc/tigmanual.7
HTMLDOC = doc/tig.1.html doc/tigrc.5.html doc/manual.html README.html INSTALL.html NEWS.html
ALLDOC	= $(MANDOC) $(HTMLDOC) doc/manual.html-chunked doc/manual.pdf

# Never include the release number in the tarname for tagged
# versions.
ifneq ($(if $(DIST_VERSION),$(words $(RPM_VERLIST))),2)
TARNAME	= tig-$(RPM_VERSION)-$(RPM_RELEASE)
else
TARNAME	= tig-$(RPM_VERSION)
endif

override CPPFLAGS += '-DTIG_VERSION="$(VERSION)"'
override CPPFLAGS += '-DSYSCONFDIR="$(sysconfdir)"'

ASCIIDOC ?= asciidoc
ASCIIDOC_FLAGS = -aversion=$(VERSION) -asysconfdir=$(sysconfdir) -f doc/asciidoc.conf
XMLTO ?= xmlto
DOCBOOK2PDF ?= docbook2pdf

all: $(EXE) $(TOOLS)
all-debug: $(EXE) $(TOOLS)
all-debug: CFLAGS += $(DFLAGS)
doc: $(ALLDOC)
doc-man: $(MANDOC)
doc-html: $(HTMLDOC)

export sysconfdir

install: all
	$(QUIET_INSTALL)tools/install.sh bin $(EXE) "$(DESTDIR)$(bindir)"
	$(QUIET_INSTALL)tools/install.sh data tigrc "$(DESTDIR)$(sysconfdir)"

install-doc-man: doc-man
	$(Q)$(foreach doc, $(filter %.1, $(MANDOC)), \
		$(QUIET_INSTALL_EACH)tools/install.sh data $(doc) "$(DESTDIR)$(mandir)/man1";)
	$(Q)$(foreach doc, $(filter %.5, $(MANDOC)), \
		$(QUIET_INSTALL_EACH)tools/install.sh data $(doc) "$(DESTDIR)$(mandir)/man5";)
	$(Q)$(foreach doc, $(filter %.7, $(MANDOC)), \
		$(QUIET_INSTALL_EACH)tools/install.sh data $(doc) "$(DESTDIR)$(mandir)/man7";)

install-release-doc-man:
	GIT_INDEX_FILE=.tmp-doc-index git read-tree origin/release
	GIT_INDEX_FILE=.tmp-doc-index git checkout-index -f --prefix=./ $(MANDOC)
	rm -f .tmp-doc-index
	$(MAKE) install-doc-man

install-doc-html: doc-html
	$(Q)$(foreach doc, $(HTMLDOC), \
		$(QUIET_INSTALL_EACH)tools/install.sh data $(doc) "$(DESTDIR)$(docdir)/tig";)

install-release-doc-html:
	GIT_INDEX_FILE=.tmp-doc-index git read-tree origin/release
	GIT_INDEX_FILE=.tmp-doc-index git checkout-index -f --prefix=./ $(HTMLDOC)
	rm -f .tmp-doc-index
	$(MAKE) install-doc-html

install-doc: install-doc-man install-doc-html
install-release-doc: install-release-doc-man install-release-doc-html

clean:
	$(RM) -r $(TARNAME) *.spec tig-*.tar.gz tig-*.tar.gz.md5 .deps
	$(RM) $(EXE) $(TOOLS) $(OBJS) core doc/*.xml src/builtin-config.c

distclean: clean
	$(RM) -r doc/manual.html-chunked autom4te.cache release-docs
	$(RM) doc/*.toc $(ALLDOC) aclocal.m4 configure
	$(RM) config.h config.log config.make config.status config.h.in

spell-check:
	for file in $(TXTDOC) src/tig.c; do \
		aspell --lang=en --dont-backup \
		       --personal=./tools/aspell.dict check $$file; \
	done

strip: $(EXE)
	strip $(EXE)

update-headers:
	@for file in include/*.h src/*.c tools/*.c; do \
		grep -q '/* Copyright' "$$file" && \
			sed '0,/.*\*\//d' < "$$file" | \
			grep -v '/* vim: set' > "$$file.tmp"; \
		{ cat tools/header.h "$$file.tmp"; \
		  echo "/* vim: set ts=8 sw=8 noexpandtab: */"; } > "$$file"; \
		rm "$$file.tmp"; \
		echo "Updated $$file"; \
	done

update-docs: tools/doc-gen
	doc="doc/tigrc.5.adoc"; \
	sed -n '0,/ifndef::DOC_GEN_ACTIONS/p' < "$$doc" > "$$doc.gen"; \
	./tools/doc-gen actions >> "$$doc.gen"; \
	sed -n '/endif::DOC_GEN_ACTIONS/,$$p' < "$$doc" >> "$$doc.gen" ; \
	mv "$$doc.gen" "$$doc"

dist: configure tig.spec
	$(Q)mkdir -p $(TARNAME) && \
	cp Makefile tig.spec configure config.h.in aclocal.m4 $(TARNAME) && \
	sed -i "s/VERSION\s\+=\s\+[0-9]\+\([.][0-9]\+\)\+/VERSION	= $(VERSION)/" $(TARNAME)/Makefile
	git archive --format=tar --prefix=$(TARNAME)/ HEAD | \
	tar --delete $(TARNAME)/Makefile > $(TARNAME).tar && \
	tar rf $(TARNAME).tar `find $(TARNAME)/*` && \
	gzip -f -9 $(TARNAME).tar && \
	md5sum $(TARNAME).tar.gz > $(TARNAME).tar.gz.md5
	$(Q)$(RM) -r $(TARNAME)

rpm: dist
	rpmbuild -ta $(TARNAME).tar.gz

test: $(TOOLS)
	test/unit-test-graph.sh
	test/builtin-config.sh

# Other autoconf-related rules are hidden in config.make.in so that
# they don't confuse Make when we aren't actually using ./configure
configure: configure.ac acinclude.m4 tools/*.m4
	./autogen.sh

.PHONY: all all-debug doc doc-man doc-html install install-doc \
	install-doc-man install-doc-html clean spell-check dist rpm test

ifdef NO_MKSTEMPS
COMPAT_CPPFLAGS += -DNO_MKSTEMPS
COMPAT_OBJS += compat/mkstemps.o
endif

ifdef NO_SETENV
COMPAT_CPPFLAGS += -DNO_SETENV
COMPAT_OBJS += compat/setenv.o
endif

ifdef NO_STRNDUP
COMPAT_CPPFLAGS += -DNO_STRNDUP
COMPAT_OBJS += compat/strndup.o
endif

COMPAT_OBJS += compat/hashtab.o

override CPPFLAGS += $(COMPAT_CPPFLAGS)

TIG_OBJS = \
	src/tig.o \
	src/types.o \
	src/string.o \
	src/util.o \
	src/argv.o \
	src/io.o \
	src/graph.o \
	src/refdb.o \
	src/builtin-config.o \
	src/request.o \
	src/line.o \
	src/keys.o \
	src/repo.o \
	src/options.o \
	src/draw.o \
	src/prompt.o \
	src/display.o \
	src/view.o \
	src/parse.o \
	src/watch.o \
	src/pager.o \
	src/log.o \
	src/diff.o \
	src/help.o \
	src/tree.o \
	src/blob.o \
	src/blame.o \
	src/refs.o \
	src/status.o \
	src/stage.o \
	src/main.o \
	src/stash.o \
	src/grep.o \
	$(COMPAT_OBJS)

src/tig: $(TIG_OBJS)

TEST_GRAPH_OBJS = test/test-graph.o src/string.o src/util.o src/io.o src/graph.o $(COMPAT_OBJS)
test/test-graph: $(TEST_GRAPH_OBJS)

DOC_GEN_OBJS = tools/doc-gen.o src/string.o src/types.o src/util.o src/request.o
tools/doc-gen: $(DOC_GEN_OBJS)

OBJS = $(sort $(TIG_OBJS) $(TEST_GRAPH_OBJS) $(DOC_GEN_OBJS))

DEPS_CFLAGS ?= -MMD -MP -MF .deps/$*.d

%: %.o
	$(QUIET_LINK)$(CC) $(CFLAGS) $(CPPFLAGS) $(LDFLAGS) $^ $(LDLIBS) -o $@

%.o: %.c $(CONFIG_H)
	@mkdir -p $(abspath .deps/$(*D))
	$(QUIET_CC)$(CC) -I. -Iinclude $(CFLAGS) $(DEPS_CFLAGS) $(CPPFLAGS) -c -o $@ $<

-include $(OBJS:%.o=.deps/%.d)

src/builtin-config.c: tigrc tools/make-builtin-config.sh
	$(QUIET_GEN)tools/make-builtin-config.sh $< > $@

tig.spec: contrib/tig.spec.in
	$(QUIET_GEN)sed -e 's/@@VERSION@@/$(RPM_VERSION)/g' \
	    -e 's/@@RELEASE@@/$(RPM_RELEASE)/g' < $< > $@

doc/manual.html: doc/manual.toc
doc/manual.html: ASCIIDOC_FLAGS += -ainclude-manual-toc
%.toc: %.adoc
	$(QUIET_GEN)sed -n '/^\[\[/,/\(---\|~~~\)/p' < $< | while read line; do \
		case "$$line" in \
		"----"*)  echo ". <<$$ref>>"; ref= ;; \
		"~~~~"*)  echo "- <<$$ref>>"; ref= ;; \
		"[["*"]]") ref="$$line" ;; \
		*)	   ref="$$ref, $$line" ;; \
		esac; done | sed 's/\[\[\(.*\)\]\]/\1/' > $@

README.html: README.adoc doc/asciidoc.conf
	$(QUIET_ASCIIDOC)$(ASCIIDOC) $(ASCIIDOC_FLAGS) -b xhtml11 -d article -a readme $<

INSTALL.html: INSTALL.adoc doc/asciidoc.conf
	$(QUIET_ASCIIDOC)$(ASCIIDOC) $(ASCIIDOC_FLAGS) -b xhtml11 -d article $<

NEWS.html: NEWS.adoc doc/asciidoc.conf
	$(QUIET_ASCIIDOC)$(ASCIIDOC) $(ASCIIDOC_FLAGS) -b xhtml11 -d article $<

doc/tigmanual.7: doc/manual.adoc

%.1.html : %.1.adoc doc/asciidoc.conf
	$(QUIET_ASCIIDOC)$(ASCIIDOC) $(ASCIIDOC_FLAGS) -b xhtml11 -d manpage $<

%.1.xml : %.1.adoc doc/asciidoc.conf
	$(QUIET_ASCIIDOC)$(ASCIIDOC) $(ASCIIDOC_FLAGS) -b docbook -d manpage $<

%.5.html : %.5.adoc doc/asciidoc.conf
	$(QUIET_ASCIIDOC)$(ASCIIDOC) $(ASCIIDOC_FLAGS) -b xhtml11 -d manpage $<

%.5.xml : %.5.adoc doc/asciidoc.conf
	$(QUIET_ASCIIDOC)$(ASCIIDOC) $(ASCIIDOC_FLAGS) -b docbook -d manpage $<

%.7.xml : %.7.adoc doc/asciidoc.conf
	$(QUIET_ASCIIDOC)$(ASCIIDOC) $(ASCIIDOC_FLAGS) -b docbook -d manpage $<

%.html: ASCIIDOC_FLAGS += -adocext=html
%.html : %.adoc doc/asciidoc.conf
	$(QUIET_ASCIIDOC)$(ASCIIDOC) $(ASCIIDOC_FLAGS) -b xhtml11 -d article -n $<

%.xml : %.adoc doc/asciidoc.conf
	$(QUIET_ASCIIDOC)$(ASCIIDOC) $(ASCIIDOC_FLAGS) -b docbook -d article $<

% : %.xml
	$(QUIET_XMLTO)$(XMLTO) man -o doc $<

%.html-chunked : %.xml
	$(QUIET_XMLTO)$(XMLTO) html -o $@ $<

%.pdf : %.xml
	$(QUIET_DB2PDF)$(DOCBOOK2PDF) -o doc $<

#############################################################################
# Quiet make
#############################################################################

ifneq ($(findstring $(MAKEFLAGS),s),s)
V			= @
Q			= $(V:1=)
QUIET_CC		= $(Q:@=@echo    '        CC  '$@;)
QUIET_LINK		= $(Q:@=@echo    '      LINK  '$@;)
QUIET_GEN		= $(Q:@=@echo    '       GEN  '$@;)
QUIET_ASCIIDOC		= $(Q:@=@echo    '  ASCIIDOC  '$@;)
QUIET_XMLTO		= $(Q:@=@echo    '     XMLTO  '$@;)
QUIET_DB2PDF		= $(Q:@=@echo    '    DB2PDF  '$@;)
# tools/install.sh will print 'file -> $install_dir/file'
QUIET_INSTALL		= $(Q:@=@printf  '   INSTALL  ';)
QUIET_INSTALL_EACH	= $(Q:@=printf   '   INSTALL  ';)

export V
endif

=== debian/changelog ===
tig (2.0.2-2build1) xenial; urgency=medium

  * No-change rebuild for ncurses6 transition.

 -- Matthias Klose <doko@ubuntu.com>  Sun, 07 Feb 2016 09:46:29 +0000

tig (2.0.2-2) UNRELEASED; urgency=medium

  * debian/patches:
    - Added bts757692-topo-order: upstream patch fixing a display regression;
      thanks to Simon Paillard for reporting this and Jonas Fonseca for a
      quick handling of the bug (Closes:  #757692).

 -- Sebastian Harl <tokkee@debian.org>  Sat, 22 Nov 2014 12:34:36 +0100

tig (2.0.2-1) unstable; urgency=medium

  [ Sebastian Harl ]
  * New upstream release; thanks to Aníbal Monsalve Salazar for reporting this
    (Closes: #746560).
  * debian/control:
    - Build-depend on libreadline-dev.
  * debian/rules:
    - Use NEWS.adoc in place of NEWS and remove BUGS which is no longer
      available.
    - Don't install contrib/tigrc as example any more. Upstream now provides
      /etc/tigrc by default.
    - Use dh_prep instead of 'dh_clean -k'.

  [ Trent W. Buck ]
  * Bump compat to 9.
  * debian/control:
    - tig enhances git.
    - Improved short description to better match the upstream description.

 -- Sebastian Harl <tokkee@debian.org>  Wed, 23 Jul 2014 10:46:04 +0200

=== debian/control ===
Source: tig
Section: vcs
Priority: optional
Maintainer: Sebastian Harl <tokkee@debian.org>
Build-Depends: debhelper (>= 9), dpkg-dev (>= 1.14.6), libncursesw5-dev, libreadline-dev,
 asciidoc (>= 8.4), xmlto, docbook-utils
Standards-Version: 3.9.4
Homepage: http://jonas.nitro.dk/tig/
Vcs-Git: git://git.tokkee.org/pkg-tig.git
Vcs-Browser: http://git.tokkee.org/?p=pkg-tig.git

Package: tig
Architecture: any
Depends: git (>= 1:1.7.0.4-2~) | git-core (>= 1:1.5.4), ${shlibs:Depends},
 ${misc:Depends}
Enhances: git
Description: ncurses-based text-mode interface for Git
 This package contains a text-mode interface for the version control system
 Git. It may be used to browse the history and contents of a repository.
 .
 The following main features are supported:
  - View revision logs, commit messages, diffstats, diffs, archive trees and
    file contents.
  - Visualize revision graphs.
  - Stage / unstage changes and add untracked files.
  - Merge files.
  - Cherry-pick commits.
 .
 tig may also be used as a pager. It reads input from stdin and colorizes it.

=== debian/rules ===
#!/usr/bin/make -f
# debian/rules for tig
#
# Written by Sebastian Harl <tokkee@debian.org>

# Uncomment this to turn on verbose mode.
#export DH_VERBOSE=1

# These are used for cross-compiling and for saving the configure script
# from having to guess our platform (since we know it already)
DEB_HOST_GNU_TYPE   ?= $(shell dpkg-architecture -qDEB_HOST_GNU_TYPE)
DEB_BUILD_GNU_TYPE  ?= $(shell dpkg-architecture -qDEB_BUILD_GNU_TYPE)

export DEB_BUILD_MAINT_OPTIONS=hardening=+all

CFLAGS   = $(shell dpkg-buildflags --get CFLAGS)
CFLAGS  += -Wall -g -I/usr/include/ncursesw

CPPFLAGS = $(shell dpkg-buildflags --get CPPFLAGS)

LDFLAGS  = $(shell dpkg-buildflags --get LDFLAGS)

ifneq (,$(findstring noopt,$(DEB_BUILD_OPTIONS)))
	CFLAGS += -O0
else
	CFLAGS += -O2
endif

config.status: configure
	dh_testdir
	./configure --host=$(DEB_HOST_GNU_TYPE) --build=$(DEB_BUILD_GNU_TYPE) \
		--prefix=/usr --mandir=\$${prefix}/share/man --sysconfdir=/etc \
		CPPFLAGS="$(CPPFLAGS)" CFLAGS="$(CFLAGS)" LDFLAGS="$(LDFLAGS)"

build: build-arch build-indep

build-arch: build-stamp
build-indep: build-stamp

build-stamp: config.status
	dh_testdir
	
	$(MAKE) all doc
	
	touch build-stamp

clean:
	dh_testdir
	dh_testroot
	rm -f build-stamp
	
	$(MAKE) clean
	
	rm -f config.h config.log config.make config.status
	rm -rf doc/manual.html-chunked/
	rm -f doc/manual.pdf doc/manual.html doc/manual.toc
	rm -f doc/tigmanual.7
	rm -f doc/tig.1 doc/tig.1.html doc/tigrc.5 doc/tigrc.5.html
	rm -f INSTALL.html NEWS.html README.html
	
	dh_clean

install: build
	dh_testdir
	dh_testroot
	dh_prep
	dh_installdirs
	
	$(MAKE) install install-doc DESTDIR=$(CURDIR)/debian/tig
	# don't ship install instructions; README only links to them
	rm -f debian/tig/usr/share/doc/tig/INSTALL.html \
		debian/tig/usr/share/doc/tig/README.html
	
	mkdir -p debian/tig/etc/bash_completion.d
	cp contrib/tig-completion.bash debian/tig/etc/bash_completion.d/tig
	chmod 644 debian/tig/etc/bash_completion.d/tig

binary-indep:
	# nothing to do here

binary-arch: build install
	dh_testdir
	dh_testroot
	dh_installchangelogs NEWS.adoc
	dh_installdocs doc/manual.pdf
	dh_installexamples
	dh_link
	dh_strip
	dh_compress -X.pdf
	dh_fixperms
	dh_installdeb
	dh_shlibdeps
	dh_gencontrol
	dh_md5sums
	dh_builddeb

binary: binary-indep binary-arch
.PHONY: build clean binary-indep binary-arch binary install

## tig 2.2

=== debian/changelog ===
tig (2.2-1) experimental; urgency=medium

  [ Sebastian Harl ]
  * New upstream release (Closes: #808134).
  * debian/rules:
    - Install sample tigrc files from contrib as examples.
  * debian/control:
    - Update standards version to 4.9.8; no changes.

  [ Satish Bysany ]
  * debian/rules:
    - Fix lintian warnings (W: package-installs-into-obsolete-dir). Install
      to usr/share/bash-completion/completions (Closes: #812931).

 -- Sebastian Harl <tokkee@debian.org>  Sat, 24 Sep 2016 15:48:31 +0200

tig (2.0.3-1) experimental; urgency=medium

  * New upstream release:
    - Fixes a regression in the graph renderer; thanks to Simon Paillard for
      reporting this (Closes: #757692).
  * Upload to experimental because of the Jessie freeze.
  * debian/rules:
    - Manually clean doc/manual.tex.
  * debian/patches:
    - Removed bts757692-topo-order: included upstream.

 -- Sebastian Harl <tokkee@debian.org>  Sun, 23 Nov 2014 17:24:40 +0100

tig (2.0.2-2) unstable; urgency=medium

  * debian/patches:
    - Added bts757692-topo-order: upstream patch fixing a display regression;
      thanks to Simon Paillard for reporting this and Jonas Fonseca for a
      quick handling of the bug (Closes: #757692).

 -- Sebastian Harl <tokkee@debian.org>  Sat, 22 Nov 2014 12:56:28 +0100

=== debian/control ===
--- 
+++ 
@@ -4,7 +4,7 @@
 Maintainer: Sebastian Harl <tokkee@debian.org>
 Build-Depends: debhelper (>= 9), dpkg-dev (>= 1.14.6), libncursesw5-dev, libreadline-dev,
  asciidoc (>= 8.4), xmlto, docbook-utils
-Standards-Version: 3.9.4
+Standards-Version: 3.9.8
 Homepage: http://jonas.nitro.dk/tig/
 Vcs-Git: git://git.tokkee.org/pkg-tig.git
 Vcs-Browser: http://git.tokkee.org/?p=pkg-tig.git

## tig 2.3.0

=== Makefile ===
--- 
+++ 
@@ -2,7 +2,7 @@
 
 # The last tagged version. Can be overridden either by the version from
 # git or from the value of the DIST_VERSION environment variable.
-VERSION	= 2.0.2
+VERSION	= 2.3.0
 
 all:
 
@@ -12,6 +12,14 @@
 
 # Include setting from the configure script
 -include config.make
+
+# Optional defaults.
+# TIG_ variables are set by contrib/config.make-$(kernel_name).
+TIG_NCURSES ?= -lcurses
+LDFLAGS ?= $(TIG_LDFLAGS)
+CPPFLAGS ?= $(TIG_CPPFLAGS)
+LDLIBS ?= $(TIG_NCURSES) $(TIG_LDLIBS)
+CFLAGS ?= -Wall -O2 $(TIG_CFLAGS)
 
 prefix ?= $(HOME)
 bindir ?= $(prefix)/bin
@@ -37,11 +45,9 @@
 RPM_VERSION = $(word 1,$(RPM_VERLIST))
 RPM_RELEASE = $(word 2,$(RPM_VERLIST))$(if $(WTDIRTY),.dirty)
 
-LDLIBS ?= -lcurses
-CFLAGS ?= -Wall -O2
 DFLAGS	= -g -DDEBUG -Werror -O0
 EXE	= src/tig
-TOOLS	= test/test-graph tools/doc-gen
+TOOLS	= test/tools/test-graph tools/doc-gen
 TXTDOC	= doc/tig.1.adoc doc/tigrc.5.adoc doc/manual.adoc NEWS.adoc README.adoc INSTALL.adoc
 MANDOC	= doc/tig.1 doc/tigrc.5 doc/tigmanual.7
 HTMLDOC = doc/tig.1.html doc/tigrc.5.html doc/manual.html README.html INSTALL.html NEWS.html
@@ -57,14 +63,25 @@
 
 override CPPFLAGS += '-DTIG_VERSION="$(VERSION)"'
 override CPPFLAGS += '-DSYSCONFDIR="$(sysconfdir)"'
+ifdef TIG_USER_CONFIG
+override CPPFLAGS += '-DTIG_USER_CONFIG="$(TIG_USER_CONFIG)"'
+endif
 
 ASCIIDOC ?= asciidoc
 ASCIIDOC_FLAGS = -aversion=$(VERSION) -asysconfdir=$(sysconfdir) -f doc/asciidoc.conf
 XMLTO ?= xmlto
 DOCBOOK2PDF ?= docbook2pdf
 
+LCOV ?= lcov
+GENHTML ?= genhtml
+ifneq (,$(shell which gsed 2>/dev/null))
+SED ?= gsed
+else
+SED ?= sed
+endif
+
 all: $(EXE) $(TOOLS)
-all-debug: $(EXE) $(TOOLS)
+all-debug: all
 all-debug: CFLAGS += $(DFLAGS)
 doc: $(ALLDOC)
 doc-man: $(MANDOC)
@@ -103,12 +120,25 @@
 install-doc: install-doc-man install-doc-html
 install-release-doc: install-release-doc-man install-release-doc-html
 
-clean:
-	$(RM) -r $(TARNAME) *.spec tig-*.tar.gz tig-*.tar.gz.md5 .deps
-	$(RM) $(EXE) $(TOOLS) $(OBJS) core doc/*.xml src/builtin-config.c
+uninstall:
+	$(QUIET_UNINSTALL)tools/uninstall.sh "$(DESTDIR)$(bindir)/$(EXE:src/%=%)"
+	$(QUIET_UNINSTALL)tools/uninstall.sh "$(DESTDIR)$(sysconfdir)/tigrc"
+	$(Q)$(foreach doc, $(filter %.1, $(MANDOC:doc/%=%)), \
+		$(QUIET_UNINSTALL_EACH)tools/uninstall.sh "$(DESTDIR)$(mandir)/man1/$(doc)";)
+	$(Q)$(foreach doc, $(filter %.5, $(MANDOC:doc/%=%)), \
+		$(QUIET_UNINSTALL_EACH)tools/uninstall.sh "$(DESTDIR)$(mandir)/man5/$(doc)";)
+	$(Q)$(foreach doc, $(filter %.7, $(MANDOC:doc/%=%)), \
+		$(QUIET_UNINSTALL_EACH)tools/uninstall.sh "$(DESTDIR)$(mandir)/man7/$(doc)";)
+	$(Q)$(foreach doc, $(HTMLDOC:doc/%=%), \
+		$(QUIET_UNINSTALL_EACH)tools/uninstall.sh "$(DESTDIR)$(docdir)/tig/$(doc)";)
+
+clean: clean-test clean-coverage
+	$(Q)$(RM) -r $(TARNAME) *.spec tig-*.tar.gz tig-*.tar.gz.md5 .deps _book node_modules
+	$(Q)$(RM) $(EXE) $(TOOLS) $(OBJS) core doc/*.xml src/builtin-config.c
+	$(Q)$(RM) $(OBJS:%.o=%.gcda) $(OBJS:%.o=%.gcno)
 
 distclean: clean
-	$(RM) -r doc/manual.html-chunked autom4te.cache release-docs
+	$(RM) -r doc/manual.html-chunked autom4te.cache
 	$(RM) doc/*.toc $(ALLDOC) aclocal.m4 configure
 	$(RM) config.h config.log config.make config.status config.h.in
 
@@ -122,9 +152,9 @@
 	strip $(EXE)
 
 update-headers:
-	@for file in include/*.h src/*.c tools/*.c; do \
+	@for file in include/tig/*.h src/*.c tools/*.c test/tools/*.c; do \
 		grep -q '/* Copyright' "$$file" && \
-			sed '0,/.*\*\//d' < "$$file" | \
+			$(SED) '0,/.*\*\//d' < "$$file" | \
 			grep -v '/* vim: set' > "$$file.tmp"; \
 		{ cat tools/header.h "$$file.tmp"; \
 		  echo "/* vim: set ts=8 sw=8 noexpandtab: */"; } > "$$file"; \
@@ -134,15 +164,15 @@
 
 update-docs: tools/doc-gen
 	doc="doc/tigrc.5.adoc"; \
-	sed -n '0,/ifndef::DOC_GEN_ACTIONS/p' < "$$doc" > "$$doc.gen"; \
+	$(SED) -n '0,/ifndef::DOC_GEN_ACTIONS/p' < "$$doc" > "$$doc.gen"; \
 	./tools/doc-gen actions >> "$$doc.gen"; \
-	sed -n '/endif::DOC_GEN_ACTIONS/,$$p' < "$$doc" >> "$$doc.gen" ; \
+	$(SED) -n '/endif::DOC_GEN_ACTIONS/,$$p' < "$$doc" >> "$$doc.gen" ; \
 	mv "$$doc.gen" "$$doc"
 
 dist: configure tig.spec
 	$(Q)mkdir -p $(TARNAME) && \
 	cp Makefile tig.spec configure config.h.in aclocal.m4 $(TARNAME) && \
-	sed -i "s/VERSION\s\+=\s\+[0-9]\+\([.][0-9]\+\)\+/VERSION	= $(VERSION)/" $(TARNAME)/Makefile
+	$(SED) -i "s/VERSION\s\+=\s\+[0-9]\+\([.][0-9]\+\)\+/VERSION	= $(VERSION)/" $(TARNAME)/Makefile
 	git archive --format=tar --prefix=$(TARNAME)/ HEAD | \
 	tar --delete $(TARNAME)/Makefile > $(TARNAME).tar && \
 	tar rf $(TARNAME).tar `find $(TARNAME)/*` && \
@@ -153,17 +183,71 @@
 rpm: dist
 	rpmbuild -ta $(TARNAME).tar.gz
 
-test: $(TOOLS)
-	test/unit-test-graph.sh
-	test/builtin-config.sh
+COVERAGE_CFLAGS ?= -fprofile-arcs -ftest-coverage
+all-coverage: all
+all-coverage: CFLAGS += $(COVERAGE_CFLAGS)
+
+COVERAGE_DIR 	?= test/coverage
+
+clean-coverage:
+	@$(RM) -rf $(COVERAGE_DIR)
+
+reset-coverage: clean-coverage
+	$(LCOV) --reset-counters
+
+test-coverage: clean-coverage all-coverage test $(COVERAGE_DIR)/index.html
+
+$(COVERAGE_DIR)/trace:
+	@mkdir -p $(COVERAGE_DIR)
+	$(QUIET_LCOV)$(LCOV) $(Q:@=--quiet) --capture --no-external --directory . --output-file $@
+
+$(COVERAGE_DIR)/index.html: $(COVERAGE_DIR)/trace
+	$(QUIET_GENHTML)$(GENHTML) $(Q:@=--quiet) --output-directory $(COVERAGE_DIR) $<
+
+ADDRESS_SANITIZER_CFLAGS ?= -fsanitize=address -fno-omit-frame-pointer
+all-address-sanitizer: all
+all-address-sanitizer: CFLAGS += $(ADDRESS_SANITIZER_CFLAGS)
+
+test-address-sanitizer: clean all-address-sanitizer test
+test-address-sanitizer: export TIG_ADDRESS_SANITIZER_ENABLED=yes
+
+TESTS  = $(sort $(shell find test -type f -name '*-test'))
+TESTS_TODO = $(sort $(shell find test -type f -name '*-test' -exec grep -l '\(test_todo\|-todo=\)' {} \+))
+
+clean-test:
+	$(Q)$(RM) -r test/tmp
+
+test: clean-test $(TESTS)
+	$(QUIET_SUMMARY)test/tools/show-results.sh
+
+ifneq (,$(strip $(V:@=)))
+export MAKE_TEST_OPTS = no-indent
+else
+export MAKE_TEST_OPTS =
+endif
+
+$(TESTS): PATH := $(CURDIR)/test/tools:$(CURDIR)/src:$(PATH)
+$(TESTS): $(EXE) test/tools/test-graph
+	$(QUIET_TEST)$(TEST_SHELL) $@
+
+test-todo: MAKE_TEST_OPTS += todo
+test-todo: $(TESTS_TODO)
 
 # Other autoconf-related rules are hidden in config.make.in so that
 # they don't confuse Make when we aren't actually using ./configure
-configure: configure.ac acinclude.m4 tools/*.m4
-	./autogen.sh
-
-.PHONY: all all-debug doc doc-man doc-html install install-doc \
-	install-doc-man install-doc-html clean spell-check dist rpm test
+configure: configure.ac tools/*.m4
+	$(QUIET_GEN)./autogen.sh
+
+site:
+	gitbook install
+	gitbook build
+	find _book -type f | grep -E -v '(gitbook|json|html)' | xargs rm
+
+.PHONY: all all-coverage all-debug clean clean-coverage clean-test doc \
+	doc-man doc-html dist distclean install install-doc \
+	install-doc-man install-doc-html install-release-doc-html \
+	install-release-doc-man rpm spell-check strip test \
+	test-coverage update-docs update-headers $(TESTS)
 
 ifdef NO_MKSTEMPS
 COMPAT_CPPFLAGS += -DNO_MKSTEMPS
@@ -180,18 +264,25 @@
 COMPAT_OBJS += compat/strndup.o
 endif
 
-COMPAT_OBJS += compat/hashtab.o
+ifdef NO_WORDEXP
+COMPAT_CPPFLAGS += -DNO_WORDEXP
+COMPAT_OBJS += compat/wordexp.o
+endif
+
+COMPAT_OBJS += compat/hashtab.o compat/wcwidth.o
 
 override CPPFLAGS += $(COMPAT_CPPFLAGS)
+
+GRAPH_OBJS = src/graph.o src/graph-v1.o src/graph-v2.o
 
 TIG_OBJS = \
 	src/tig.o \
 	src/types.o \
 	src/string.o \
 	src/util.o \
+	src/map.o \
 	src/argv.o \
 	src/io.o \
-	src/graph.o \
 	src/refdb.o \
 	src/builtin-config.o \
 	src/request.o \
@@ -203,6 +294,7 @@
 	src/prompt.o \
 	src/display.o \
 	src/view.o \
+	src/search.o \
 	src/parse.o \
 	src/watch.o \
 	src/pager.o \
@@ -218,14 +310,16 @@
 	src/main.o \
 	src/stash.o \
 	src/grep.o \
+	src/ui.o \
+	$(GRAPH_OBJS) \
 	$(COMPAT_OBJS)
 
 src/tig: $(TIG_OBJS)
 
-TEST_GRAPH_OBJS = test/test-graph.o src/string.o src/util.o src/io.o src/graph.o $(COMPAT_OBJS)
-test/test-graph: $(TEST_GRAPH_OBJS)
-
-DOC_GEN_OBJS = tools/doc-gen.o src/string.o src/types.o src/util.o src/request.o
+TEST_GRAPH_OBJS = test/tools/test-graph.o src/string.o src/util.o src/io.o $(GRAPH_OBJS) $(COMPAT_OBJS)
+test/tools/test-graph: $(TEST_GRAPH_OBJS)
+
+DOC_GEN_OBJS = tools/doc-gen.o src/string.o src/types.o src/util.o src/request.o compat/wcwidth.o
 tools/doc-gen: $(DOC_GEN_OBJS)
 
 OBJS = $(sort $(TIG_OBJS) $(TEST_GRAPH_OBJS) $(DOC_GEN_OBJS))
@@ -236,7 +330,7 @@
 	$(QUIET_LINK)$(CC) $(CFLAGS) $(CPPFLAGS) $(LDFLAGS) $^ $(LDLIBS) -o $@
 
 %.o: %.c $(CONFIG_H)
-	@mkdir -p $(abspath .deps/$(*D))
+	@mkdir -p .deps/$(*D)
 	$(QUIET_CC)$(CC) -I. -Iinclude $(CFLAGS) $(DEPS_CFLAGS) $(CPPFLAGS) -c -o $@ $<
 
 -include $(OBJS:%.o=.deps/%.d)
@@ -245,19 +339,19 @@
 	$(QUIET_GEN)tools/make-builtin-config.sh $< > $@
 
 tig.spec: contrib/tig.spec.in
-	$(QUIET_GEN)sed -e 's/@@VERSION@@/$(RPM_VERSION)/g' \
+	$(QUIET_GEN)$(SED) -e 's/@@VERSION@@/$(RPM_VERSION)/g' \
 	    -e 's/@@RELEASE@@/$(RPM_RELEASE)/g' < $< > $@
 
 doc/manual.html: doc/manual.toc
 doc/manual.html: ASCIIDOC_FLAGS += -ainclude-manual-toc
 %.toc: %.adoc
-	$(QUIET_GEN)sed -n '/^\[\[/,/\(---\|~~~\)/p' < $< | while read line; do \
+	$(QUIET_GEN)$(SED) -n '/^\[\[/,/\(---\|~~~\)/p' < $< | while read line; do \
 		case "$$line" in \
 		"----"*)  echo ". <<$$ref>>"; ref= ;; \
 		"~~~~"*)  echo "- <<$$ref>>"; ref= ;; \
 		"[["*"]]") ref="$$line" ;; \
 		*)	   ref="$$ref, $$line" ;; \
-		esac; done | sed 's/\[\[\(.*\)\]\]/\1/' > $@
+		esac; done | $(SED) 's/\[\[\(.*\)\]\]/\1/' > $@
 
 README.html: README.adoc doc/asciidoc.conf
 	$(QUIET_ASCIIDOC)$(ASCIIDOC) $(ASCIIDOC_FLAGS) -b xhtml11 -d article -a readme $<
@@ -296,27 +390,3 @@
 	$(QUIET_XMLTO)$(XMLTO) man -o doc $<
 
 %.html-chunked : %.xml
-	$(QUIET_XMLTO)$(XMLTO) html -o $@ $<
-
-%.pdf : %.xml
-	$(QUIET_DB2PDF)$(DOCBOOK2PDF) -o doc $<
-
-#############################################################################
-# Quiet make
-#############################################################################
-
-ifneq ($(findstring $(MAKEFLAGS),s),s)
-V			= @
-Q			= $(V:1=)
-QUIET_CC		= $(Q:@=@echo    '        CC  '$@;)
-QUIET_LINK		= $(Q:@=@echo    '      LINK  '$@;)
-QUIET_GEN		= $(Q:@=@echo    '       GEN  '$@;)
-QUIET_ASCIIDOC		= $(Q:@=@echo    '  ASCIIDOC  '$@;)
-QUIET_XMLTO		= $(Q:@=@echo    '     XMLTO  '$@;)
-QUIET_DB2PDF		= $(Q:@=@echo    '    DB2PDF  '$@;)
-# tools/install.sh will print 'file -> $install_dir/file'
-QUIET_INSTALL		= $(Q:@=@printf  '   INSTALL  ';)
-QUIET_INSTALL_EACH	= $(Q:@=printf   '   INSTALL  ';)
-
-export V
-endif

=== debian/changelog ===
tig (2.3.0-1) unstable; urgency=medium

  * New upstream release.
    - Updated debian/watch to point to the new Github location.
  * Update standards version to 4.1.1; no changes.

 -- Sebastian Harl <tokkee@debian.org>  Sun, 22 Oct 2017 15:38:27 +0200

=== debian/control ===
--- 
+++ 
@@ -4,7 +4,7 @@
 Maintainer: Sebastian Harl <tokkee@debian.org>
 Build-Depends: debhelper (>= 9), dpkg-dev (>= 1.14.6), libncursesw5-dev, libreadline-dev,
  asciidoc (>= 8.4), xmlto, docbook-utils
-Standards-Version: 3.9.8
+Standards-Version: 4.1.1
 Homepage: http://jonas.nitro.dk/tig/
 Vcs-Git: git://git.tokkee.org/pkg-tig.git
 Vcs-Browser: http://git.tokkee.org/?p=pkg-tig.git

## tig 2.4.1

=== Makefile ===
--- 
+++ 
@@ -2,7 +2,7 @@
 
 # The last tagged version. Can be overridden either by the version from
 # git or from the value of the DIST_VERSION environment variable.
-VERSION	= 2.3.0
+VERSION	= 2.4.1
 
 all:
 
@@ -48,7 +48,7 @@
 DFLAGS	= -g -DDEBUG -Werror -O0
 EXE	= src/tig
 TOOLS	= test/tools/test-graph tools/doc-gen
-TXTDOC	= doc/tig.1.adoc doc/tigrc.5.adoc doc/manual.adoc NEWS.adoc README.adoc INSTALL.adoc
+TXTDOC	= doc/tig.1.adoc doc/tigrc.5.adoc doc/manual.adoc NEWS.adoc README.adoc INSTALL.adoc test/API.adoc
 MANDOC	= doc/tig.1 doc/tigrc.5 doc/tigmanual.7
 HTMLDOC = doc/tig.1.html doc/tigrc.5.html doc/manual.html README.html INSTALL.html NEWS.html
 ALLDOC	= $(MANDOC) $(HTMLDOC) doc/manual.html-chunked doc/manual.pdf
@@ -269,7 +269,7 @@
 COMPAT_OBJS += compat/wordexp.o
 endif
 
-COMPAT_OBJS += compat/hashtab.o compat/wcwidth.o
+COMPAT_OBJS += compat/hashtab.o compat/utf8proc.o
 
 override CPPFLAGS += $(COMPAT_CPPFLAGS)
 
@@ -311,6 +311,7 @@
 	src/stash.o \
 	src/grep.o \
 	src/ui.o \
+	src/apps.o \
 	$(GRAPH_OBJS) \
 	$(COMPAT_OBJS)
 
@@ -319,7 +320,7 @@
 TEST_GRAPH_OBJS = test/tools/test-graph.o src/string.o src/util.o src/io.o $(GRAPH_OBJS) $(COMPAT_OBJS)
 test/tools/test-graph: $(TEST_GRAPH_OBJS)
 
-DOC_GEN_OBJS = tools/doc-gen.o src/string.o src/types.o src/util.o src/request.o compat/wcwidth.o
+DOC_GEN_OBJS = tools/doc-gen.o src/string.o src/types.o src/util.o src/request.o $(COMPAT_OBJS)
 tools/doc-gen: $(DOC_GEN_OBJS)
 
 OBJS = $(sort $(TIG_OBJS) $(TEST_GRAPH_OBJS) $(DOC_GEN_OBJS))
@@ -364,6 +365,10 @@
 
 doc/tigmanual.7: doc/manual.adoc
 
+test/API.adoc: test/tools/libtest.sh
+	@printf '%s\n%s\n' 'Testing API' '-----------' > $@
+	$(QUIET_ASCIIDOC)egrep '^#\|' test/tools/libtest.sh | $(SED) 's/^#| \{0,1\}//' | cat -s >> $@
+
 %.1.html : %.1.adoc doc/asciidoc.conf
 	$(QUIET_ASCIIDOC)$(ASCIIDOC) $(ASCIIDOC_FLAGS) -b xhtml11 -d manpage $<
 
@@ -381,12 +386,3 @@
 
 %.html: ASCIIDOC_FLAGS += -adocext=html
 %.html : %.adoc doc/asciidoc.conf
-	$(QUIET_ASCIIDOC)$(ASCIIDOC) $(ASCIIDOC_FLAGS) -b xhtml11 -d article -n $<
-
-%.xml : %.adoc doc/asciidoc.conf
-	$(QUIET_ASCIIDOC)$(ASCIIDOC) $(ASCIIDOC_FLAGS) -b docbook -d article $<
-
-% : %.xml
-	$(QUIET_XMLTO)$(XMLTO) man -o doc $<
-
-%.html-chunked : %.xml

=== debian/changelog ===
tig (2.4.1-1) unstable; urgency=medium

  * New upstream version.
  * debian/control:
    - Build depend on readline >= 6.3; that's the min version specified by
      upstream.
    - Update standards version to 4.2.1:
      - Change Vcs-Browser URL from HTTP to HTTPS.
  * debian/maintscript:
    - Clean up obsolete /etc/bash_completion.d/tig; thanks to Christoph Anton
      Mitterer for reporting this (Closes: #868091).

 -- Sebastian Harl <tokkee@debian.org>  Thu, 08 Nov 2018 23:08:23 +0100

=== debian/control ===
--- 
+++ 
@@ -2,12 +2,12 @@
 Section: vcs
 Priority: optional
 Maintainer: Sebastian Harl <tokkee@debian.org>
-Build-Depends: debhelper (>= 9), dpkg-dev (>= 1.14.6), libncursesw5-dev, libreadline-dev,
- asciidoc (>= 8.4), xmlto, docbook-utils
-Standards-Version: 4.1.1
+Build-Depends: debhelper (>= 9), dpkg-dev (>= 1.14.6), libncursesw5-dev,
+ libreadline-dev (>= 6.3), asciidoc (>= 8.4), xmlto, docbook-utils
+Standards-Version: 4.2.1
 Homepage: http://jonas.nitro.dk/tig/
 Vcs-Git: git://git.tokkee.org/pkg-tig.git
-Vcs-Browser: http://git.tokkee.org/?p=pkg-tig.git
+Vcs-Browser: https://git.tokkee.org/?p=pkg-tig.git
 
 Package: tig
 Architecture: any

=== debian/rules ===
--- 
+++ 
@@ -53,7 +53,7 @@
 	
 	rm -f config.h config.log config.make config.status
 	rm -rf doc/manual.html-chunked/
-	rm -f doc/manual.pdf doc/manual.html doc/manual.toc
+	rm -f doc/manual.pdf doc/manual.html doc/manual.toc doc/manual.tex
 	rm -f doc/tigmanual.7
 	rm -f doc/tig.1 doc/tig.1.html doc/tigrc.5 doc/tigrc.5.html
 	rm -f INSTALL.html NEWS.html README.html
@@ -71,9 +71,9 @@
 	rm -f debian/tig/usr/share/doc/tig/INSTALL.html \
 		debian/tig/usr/share/doc/tig/README.html
 	
-	mkdir -p debian/tig/etc/bash_completion.d
-	cp contrib/tig-completion.bash debian/tig/etc/bash_completion.d/tig
-	chmod 644 debian/tig/etc/bash_completion.d/tig
+	mkdir -p debian/tig/usr/share/bash-completion/completions
+	cp contrib/tig-completion.bash debian/tig/usr/share/bash-completion/completions/tig
+	chmod 644 debian/tig/usr/share/bash-completion/completions/tig
 
 binary-indep:
 	# nothing to do here
@@ -83,7 +83,7 @@
 	dh_testroot
 	dh_installchangelogs NEWS.adoc
 	dh_installdocs doc/manual.pdf
-	dh_installexamples
+	dh_installexamples contrib/*.tigrc
 	dh_link
 	dh_strip
 	dh_compress -X.pdf

## tig 2.5.1

=== Makefile ===
--- 
+++ 
@@ -2,7 +2,7 @@
 
 # The last tagged version. Can be overridden either by the version from
 # git or from the value of the DIST_VERSION environment variable.
-VERSION	= 2.4.1
+VERSION	= 2.5.1
 
 all:
 
@@ -78,6 +78,11 @@
 SED ?= gsed
 else
 SED ?= sed
+endif
+ifneq (,$(shell which gtar 2>/dev/null))
+TAR ?= gtar
+else
+TAR ?= tar
 endif
 
 all: $(EXE) $(TOOLS)
@@ -174,9 +179,9 @@
 	cp Makefile tig.spec configure config.h.in aclocal.m4 $(TARNAME) && \
 	$(SED) -i "s/VERSION\s\+=\s\+[0-9]\+\([.][0-9]\+\)\+/VERSION	= $(VERSION)/" $(TARNAME)/Makefile
 	git archive --format=tar --prefix=$(TARNAME)/ HEAD | \
-	tar --delete $(TARNAME)/Makefile > $(TARNAME).tar && \
-	tar rf $(TARNAME).tar `find $(TARNAME)/*` && \
-	gzip -f -9 $(TARNAME).tar && \
+	$(TAR) --delete $(TARNAME)/Makefile > $(TARNAME).tar && \
+	find $(TARNAME) -type f -print0 | LC_ALL=C sort -z | $(TAR) --mtime=$(shell git show -s --format=@%ct) --mode=o=rX,ug+rw,a-s --owner=root --group=root --null -T - -rf $(TARNAME).tar && \
+	gzip -f -n -9 $(TARNAME).tar && \
 	md5sum $(TARNAME).tar.gz > $(TARNAME).tar.gz.md5
 	$(Q)$(RM) -r $(TARNAME)
 
@@ -299,6 +304,7 @@
 	src/watch.o \
 	src/pager.o \
 	src/log.o \
+	src/reflog.o \
 	src/diff.o \
 	src/help.o \
 	src/tree.o \
@@ -381,8 +387,3 @@
 %.5.xml : %.5.adoc doc/asciidoc.conf
 	$(QUIET_ASCIIDOC)$(ASCIIDOC) $(ASCIIDOC_FLAGS) -b docbook -d manpage $<
 
-%.7.xml : %.7.adoc doc/asciidoc.conf
-	$(QUIET_ASCIIDOC)$(ASCIIDOC) $(ASCIIDOC_FLAGS) -b docbook -d manpage $<
-
-%.html: ASCIIDOC_FLAGS += -adocext=html
-%.html : %.adoc doc/asciidoc.conf

=== debian/changelog ===
tig (2.5.1-1) unstable; urgency=medium

  * New upstream release (Closes: #963005).
    - Fixes segfault with readline 8; thanks to Marco Trevisan for reporting
      this (Closes: #944123).
  * Update standards-version to 4.5.1 and compat to 12; no changes.

 -- Sebastian Harl <tokkee@debian.org>  Tue, 05 Jan 2021 23:30:32 +0100

=== debian/control ===
--- 
+++ 
@@ -2,9 +2,9 @@
 Section: vcs
 Priority: optional
 Maintainer: Sebastian Harl <tokkee@debian.org>
-Build-Depends: debhelper (>= 9), dpkg-dev (>= 1.14.6), libncursesw5-dev,
+Build-Depends: debhelper (>= 12), dpkg-dev (>= 1.14.6), libncursesw5-dev,
  libreadline-dev (>= 6.3), asciidoc (>= 8.4), xmlto, docbook-utils
-Standards-Version: 4.2.1
+Standards-Version: 4.5.1
 Homepage: http://jonas.nitro.dk/tig/
 Vcs-Git: git://git.tokkee.org/pkg-tig.git
 Vcs-Browser: https://git.tokkee.org/?p=pkg-tig.git

## tig 2.5.5

=== Makefile ===
--- 
+++ 
@@ -2,7 +2,7 @@
 
 # The last tagged version. Can be overridden either by the version from
 # git or from the value of the DIST_VERSION environment variable.
-VERSION	= 2.5.1
+VERSION	= 2.5.5
 
 all:
 
@@ -85,12 +85,50 @@
 TAR ?= tar
 endif
 
+GENERATE_COMPILATION_DATABASE ?= no
+ifeq ($(GENERATE_COMPILATION_DATABASE),yes)
+compdb_check = $(shell $(CC) $(ALL_CFLAGS) \
+	-c -MJ /dev/null \
+	-x c /dev/null -o /dev/null 2>&1; \
+	echo $$?)
+ifneq ($(compdb_check),0)
+override GENERATE_COMPILATION_DATABASE = no
+$(warning GENERATE_COMPILATION_DATABASE is set to "yes", but your compiler does not \
+support generating compilation database entries)
+endif
+else
+ifneq ($(GENERATE_COMPILATION_DATABASE),no)
+$(error please set GENERATE_COMPILATION_DATABASE to "yes" or "no" \
+(not "$(GENERATE_COMPILATION_DATABASE)"))
+endif
+endif
+
+compdb_dir = compile_commands
+ifeq ($(GENERATE_COMPILATION_DATABASE),yes)
+missing_compdb_dir = $(compdb_dir)
+$(missing_compdb_dir):
+	@mkdir -p $@
+
+compdb_file = $(compdb_dir)/$(subst /,-,$@.json)
+compdb_args = -MJ $(compdb_file)
+else
+missing_compdb_dir = 
+compdb_args =
+endif
+
 all: $(EXE) $(TOOLS)
 all-debug: all
 all-debug: CFLAGS += $(DFLAGS)
 doc: $(ALLDOC)
 doc-man: $(MANDOC)
 doc-html: $(HTMLDOC)
+
+ifeq ($(GENERATE_COMPILATION_DATABASE),yes)
+all: compile_commands.json
+compile_commands.json:
+	$(QUIET_GEN)sed -e '1s/^/[/' -e '$$s/,$$/]/' $(compdb_dir)/*.o.json > $@+
+	@if test -s $@+; then mv $@+ $@; else $(RM) $@+; fi
+endif
 
 export sysconfdir
 
@@ -138,14 +176,18 @@
 		$(QUIET_UNINSTALL_EACH)tools/uninstall.sh "$(DESTDIR)$(docdir)/tig/$(doc)";)
 
 clean: clean-test clean-coverage
-	$(Q)$(RM) -r $(TARNAME) *.spec tig-*.tar.gz tig-*.tar.gz.md5 .deps _book node_modules
+	$(Q)$(RM) -r $(TARNAME) tig-*.tar.gz tig-*.tar.gz.sha256 .deps _book node_modules
+	$(Q)$(RM) -r $(compdb_dir) compile_commands.json
 	$(Q)$(RM) $(EXE) $(TOOLS) $(OBJS) core doc/*.xml src/builtin-config.c
 	$(Q)$(RM) $(OBJS:%.o=%.gcda) $(OBJS:%.o=%.gcno)
 
 distclean: clean
 	$(RM) -r doc/manual.html-chunked autom4te.cache
-	$(RM) doc/*.toc $(ALLDOC) aclocal.m4 configure
-	$(RM) config.h config.log config.make config.status config.h.in
+	$(RM) doc/*.toc configure~
+	$(RM) config.h config.log config.make config.status config.h.in~
+
+veryclean: distclean
+	$(RM) tig.spec $(ALLDOC) aclocal.m4 configure config.h.in
 
 spell-check:
 	for file in $(TXTDOC) src/tig.c; do \
@@ -174,7 +216,7 @@
 	$(SED) -n '/endif::DOC_GEN_ACTIONS/,$$p' < "$$doc" >> "$$doc.gen" ; \
 	mv "$$doc.gen" "$$doc"
 
-dist: configure tig.spec
+dist: configure config.h.in aclocal.m4 tig.spec
 	$(Q)mkdir -p $(TARNAME) && \
 	cp Makefile tig.spec configure config.h.in aclocal.m4 $(TARNAME) && \
 	$(SED) -i "s/VERSION\s\+=\s\+[0-9]\+\([.][0-9]\+\)\+/VERSION	= $(VERSION)/" $(TARNAME)/Makefile
@@ -182,7 +224,7 @@
 	$(TAR) --delete $(TARNAME)/Makefile > $(TARNAME).tar && \
 	find $(TARNAME) -type f -print0 | LC_ALL=C sort -z | $(TAR) --mtime=$(shell git show -s --format=@%ct) --mode=o=rX,ug+rw,a-s --owner=root --group=root --null -T - -rf $(TARNAME).tar && \
 	gzip -f -n -9 $(TARNAME).tar && \
-	md5sum $(TARNAME).tar.gz > $(TARNAME).tar.gz.md5
+	sha256sum $(TARNAME).tar.gz > $(TARNAME).tar.gz.sha256
 	$(Q)$(RM) -r $(TARNAME)
 
 rpm: dist
@@ -240,7 +282,7 @@
 
 # Other autoconf-related rules are hidden in config.make.in so that
 # they don't confuse Make when we aren't actually using ./configure
-configure: configure.ac tools/*.m4
+configure config.h.in aclocal.m4: configure.ac tools/*.m4
 	$(QUIET_GEN)./autogen.sh
 
 site:
@@ -252,7 +294,7 @@
 	doc-man doc-html dist distclean install install-doc \
 	install-doc-man install-doc-html install-release-doc-html \
 	install-release-doc-man rpm spell-check strip test \
-	test-coverage update-docs update-headers $(TESTS)
+	test-coverage update-docs update-headers veryclean $(TESTS)
 
 ifdef NO_MKSTEMPS
 COMPAT_CPPFLAGS += -DNO_MKSTEMPS
@@ -336,9 +378,9 @@
 %: %.o
 	$(QUIET_LINK)$(CC) $(CFLAGS) $(CPPFLAGS) $(LDFLAGS) $^ $(LDLIBS) -o $@
 
-%.o: %.c $(CONFIG_H)
+%.o: %.c $(CONFIG_H) $(missing_compdb_dir)
 	@mkdir -p .deps/$(*D)
-	$(QUIET_CC)$(CC) -I. -Iinclude $(CFLAGS) $(DEPS_CFLAGS) $(CPPFLAGS) -c -o $@ $<
+	$(QUIET_CC)$(CC) -I. -Iinclude $(compdb_args) $(CFLAGS) $(DEPS_CFLAGS) $(CPPFLAGS) -c -o $@ $<
 
 -include $(OBJS:%.o=.deps/%.d)
 
@@ -352,38 +394,3 @@
 doc/manual.html: doc/manual.toc
 doc/manual.html: ASCIIDOC_FLAGS += -ainclude-manual-toc
 %.toc: %.adoc
-	$(QUIET_GEN)$(SED) -n '/^\[\[/,/\(---\|~~~\)/p' < $< | while read line; do \
-		case "$$line" in \
-		"----"*)  echo ". <<$$ref>>"; ref= ;; \
-		"~~~~"*)  echo "- <<$$ref>>"; ref= ;; \
-		"[["*"]]") ref="$$line" ;; \
-		*)	   ref="$$ref, $$line" ;; \
-		esac; done | $(SED) 's/\[\[\(.*\)\]\]/\1/' > $@
-
-README.html: README.adoc doc/asciidoc.conf
-	$(QUIET_ASCIIDOC)$(ASCIIDOC) $(ASCIIDOC_FLAGS) -b xhtml11 -d article -a readme $<
-
-INSTALL.html: INSTALL.adoc doc/asciidoc.conf
-	$(QUIET_ASCIIDOC)$(ASCIIDOC) $(ASCIIDOC_FLAGS) -b xhtml11 -d article $<
-
-NEWS.html: NEWS.adoc doc/asciidoc.conf
-	$(QUIET_ASCIIDOC)$(ASCIIDOC) $(ASCIIDOC_FLAGS) -b xhtml11 -d article $<
-
-doc/tigmanual.7: doc/manual.adoc
-
-test/API.adoc: test/tools/libtest.sh
-	@printf '%s\n%s\n' 'Testing API' '-----------' > $@
-	$(QUIET_ASCIIDOC)egrep '^#\|' test/tools/libtest.sh | $(SED) 's/^#| \{0,1\}//' | cat -s >> $@
-
-%.1.html : %.1.adoc doc/asciidoc.conf
-	$(QUIET_ASCIIDOC)$(ASCIIDOC) $(ASCIIDOC_FLAGS) -b xhtml11 -d manpage $<
-
-%.1.xml : %.1.adoc doc/asciidoc.conf
-	$(QUIET_ASCIIDOC)$(ASCIIDOC) $(ASCIIDOC_FLAGS) -b docbook -d manpage $<
-
-%.5.html : %.5.adoc doc/asciidoc.conf
-	$(QUIET_ASCIIDOC)$(ASCIIDOC) $(ASCIIDOC_FLAGS) -b xhtml11 -d manpage $<
-
-%.5.xml : %.5.adoc doc/asciidoc.conf
-	$(QUIET_ASCIIDOC)$(ASCIIDOC) $(ASCIIDOC_FLAGS) -b docbook -d manpage $<
-

=== debian/changelog ===
tig (2.5.5-1) unstable; urgency=medium

  * New upstream release; thanks to Elimar Riesebieter for reporting this
    (Closes: #990887).
    - Build-depend on libpcre2-dev.
  * Update homepage field; thanks to Elimar Riesebieter for reporting this
    (Closes: #990886).

 -- Sebastian Harl <tokkee@debian.org>  Sat, 26 Feb 2022 13:58:05 +0100

=== debian/control ===
--- 
+++ 
@@ -2,10 +2,15 @@
 Section: vcs
 Priority: optional
 Maintainer: Sebastian Harl <tokkee@debian.org>
-Build-Depends: debhelper (>= 12), dpkg-dev (>= 1.14.6), libncursesw5-dev,
- libreadline-dev (>= 6.3), asciidoc (>= 8.4), xmlto, docbook-utils
+Build-Depends: debhelper (>= 12), dpkg-dev (>= 1.14.6),
+ libncursesw5-dev,
+ libpcre2-dev,
+ libreadline-dev (>= 6.3),
+ asciidoc (>= 8.4),
+ docbook-utils,
+ xmlto
 Standards-Version: 4.5.1
-Homepage: http://jonas.nitro.dk/tig/
+Homepage: https://jonas.github.io/tig/
 Vcs-Git: git://git.tokkee.org/pkg-tig.git
 Vcs-Browser: https://git.tokkee.org/?p=pkg-tig.git

=== debian/rules ===
--- 
+++ 
@@ -19,12 +19,6 @@
 CPPFLAGS = $(shell dpkg-buildflags --get CPPFLAGS)
 
 LDFLAGS  = $(shell dpkg-buildflags --get LDFLAGS)
-
-ifneq (,$(findstring noopt,$(DEB_BUILD_OPTIONS)))
-	CFLAGS += -O0
-else
-	CFLAGS += -O2
-endif
 
 config.status: configure
 	dh_testdir

## tig 2.5.8

=== Makefile ===
--- 
+++ 
@@ -2,7 +2,7 @@
 
 # The last tagged version. Can be overridden either by the version from
 # git or from the value of the DIST_VERSION environment variable.
-VERSION	= 2.5.5
+VERSION	= 2.5.8
 
 all:

=== debian/changelog ===
tig (2.5.8-1build2) noble; urgency=medium

  * No-change rebuild for CVE-2024-3094

 -- William Grant <wgrant@ubuntu.com>  Mon, 01 Apr 2024 19:25:45 +1100

tig (2.5.8-1build1) noble; urgency=medium

  * No-change rebuild for readline time64 change.

 -- Matthias Klose <doko@ubuntu.com>  Thu, 14 Mar 2024 03:01:56 +0100

tig (2.5.8-1) unstable; urgency=medium

  * New upstream release; thanks to Nicolas Dechesne for reporting this
    (Closes: #1040527).
  * debian/watch:
    - Use api.github.com to make sure it works with the new, JavaScript
      created release page.
  * debian/control:
    - Build-depend on libncurses-dev instead of deprecated libncursesw5-dev.

 -- Sebastian Harl <tokkee@debian.org>  Sun, 01 Oct 2023 11:17:09 +0200

=== debian/control ===
--- 
+++ 
@@ -1,9 +1,10 @@
 Source: tig
 Section: vcs
 Priority: optional
-Maintainer: Sebastian Harl <tokkee@debian.org>
+Maintainer: Ubuntu Developers <ubuntu-devel-discuss@lists.ubuntu.com>
+XSBC-Original-Maintainer: Sebastian Harl <tokkee@debian.org>
 Build-Depends: debhelper (>= 12), dpkg-dev (>= 1.14.6),
- libncursesw5-dev,
+ libncurses-dev,
  libpcre2-dev,
  libreadline-dev (>= 6.3),
  asciidoc (>= 8.4),

=== debian/watch ===
version=4
opts="searchmode=plain" \
https://api.github.com/repos/jonas/tig/releases?per_page=50 \
https://github.com/jonas/tig/releases/download/tig-[^/]*/tig-@ANY_VERSION@\.tar\.gz

## tig 2.6.0

=== debian/changelog ===
tig (2.6.0-2) unstable; urgency=medium

  * d/rules: Replace build flags with DPKG_EXPORT_BUILDFLAGS
  * Revamp build scripts
  * Patch tests to use /usr/bin/tig when SYSTEM_TIG=1
  * Add upstream tests as autopkgtest

 -- Lee Garrett <debian@rocketjump.eu>  Sat, 20 Dec 2025 15:28:56 +0100

tig (2.6.0-1) unstable; urgency=medium

  * Salvage package with approval of current maintainer, re-adding tokkee as
    Uploader (#1086016#25).
    Thank you, tokkee, for nearly 20 years of dedication and care in maintaining
    tig. Your commitment is much appreciated by users and DDs alike!
  * Add d/gbp.conf and switch to DEP-14 layout
  * New upstream version 2.6.0 (Closes: #1086016)
  * d/copyright: Remove FSF postal address and make lintian happy
  * Update Standards-Version (no changes needed)
  * Move packaging repo to salsa and update URIs in d/control

 -- Lee Garrett <debian@rocketjump.eu>  Fri, 19 Dec 2025 14:57:06 +0100

=== debian/control ===
--- 
+++ 
@@ -1,19 +1,23 @@
 Source: tig
 Section: vcs
 Priority: optional
-Maintainer: Ubuntu Developers <ubuntu-devel-discuss@lists.ubuntu.com>
-XSBC-Original-Maintainer: Sebastian Harl <tokkee@debian.org>
-Build-Depends: debhelper (>= 12), dpkg-dev (>= 1.14.6),
- libncurses-dev,
- libpcre2-dev,
- libreadline-dev (>= 6.3),
- asciidoc (>= 8.4),
- docbook-utils,
- xmlto
-Standards-Version: 4.5.1
+Maintainer: Lee Garrett <debian@rocketjump.eu>
+Uploaders: Sebastian Harl <tokkee@debian.org>
+Build-Depends:
+  asciidoc (>= 8.4),
+  debhelper-compat (= 13),
+  docbook-utils,
+  dh-exec,
+  dpkg-dev (>= 1.14.6),
+  libncurses-dev,
+  libpcre2-dev,
+  libreadline-dev (>= 6.3),
+  pkgconf,
+  xmlto,
+Standards-Version: 4.7.2
 Homepage: https://jonas.github.io/tig/
-Vcs-Git: git://git.tokkee.org/pkg-tig.git
-Vcs-Browser: https://git.tokkee.org/?p=pkg-tig.git
+Vcs-Browser: https://salsa.debian.org/debian/tig
+Vcs-Git: https://salsa.debian.org/debian/tig.git
 
 Package: tig
 Architecture: any
@@ -33,4 +37,3 @@
   - Cherry-pick commits.
  .
  tig may also be used as a pager. It reads input from stdin and colorizes it.
-

=== debian/rules ===
#!/usr/bin/make -f
# debian/rules for tig
#
# Written by Sebastian Harl <tokkee@debian.org>

# Uncomment this to turn on verbose mode.
#export DH_VERBOSE=1

# These are used for cross-compiling and for saving the configure script
# from having to guess our platform (since we know it already)
DEB_HOST_GNU_TYPE   ?= $(shell dpkg-architecture -qDEB_HOST_GNU_TYPE)
DEB_BUILD_GNU_TYPE  ?= $(shell dpkg-architecture -qDEB_BUILD_GNU_TYPE)

export DEB_BUILD_MAINT_OPTIONS=hardening=+all
DPKG_EXPORT_BUILDFLAGS = 1
include /usr/share/dpkg/buildflags.mk

export DESTDIR=$(CURDIR)/debian/tig

%:
	dh $@

execute_after_dh_auto_build:
	$(MAKE) doc

execute_after_dh_auto_install:
	$(MAKE) install-doc
	rm $(DESTDIR)/usr/share/doc/tig/INSTALL.html
	rm $(DESTDIR)/usr/share/doc/tig/README.html

execute_after_dh_install:
	chmod -x $(DESTDIR)/usr/share/bash-completion/completions/tig

override_dh_auto_test:

override_dh_compress:
	dh_compress -X.pdf

override_dh_installchangelogs:
	dh_installchangelogs NEWS.adoc

=== debian/tests/control ===
Tests: upstream-tests
Depends:
  @,
  build-essential,
  libncurses-dev,
  locales-all,
